/**
 * @file
 * Font Iconpicker behavior.
 */

(($, Drupal, once) => {
  Drupal.behaviors.fontIconpicker = {
    attach(context, settings) {
      $(once("jsFontIconpicker", "select.font-iconpicker-element", context)).each((index, element) => {
        const $element = $(element);

        // Initialize icon picker.
        $element.fontIconPicker({
          theme: `fip-${settings.font_iconpicker.theme}`,
          emptyIcon: !!$element.attr(`${settings.font_iconpicker.data_attribute_prefix}empty-icon`),
          hasSearch: !!$element.attr(`${settings.font_iconpicker.data_attribute_prefix}has-search`),
          iconGenerator: function (icon) {
            let iconClass = [icon];

            if (settings.font_iconpicker.additional_class) {
              iconClass.push(settings.font_iconpicker.additional_class);
            }

            return '<i class="' + iconClass.join(' ')  + '"></i>';
          }
        });
      });
    }
  };
})(jQuery, Drupal, once);
